/*
  LMX2330/2331/2332 "Three wire" controller with Arduino
  Prescaller 100/1000 (or other value)  
  Source:http://www.g8ajn.tv/dlother3.html
  Modified by YO4HFU / 2017
  ******************************************************
  ARDUINO pins: 
  Switch = Pin 8
  PLL LE = Pin 9 
  PLL DATA = Pin 10  
  PLL CLK = Pin 11 
  LED = pin 13
  Switch connected between pin 8 and GND. Is used to change divider ratio 100 or 1000, mode confirmed by LED.
  *******************************************************
  CLOCK WIDTH = 0,005 msec
 */
 
 //Registers calculated by Code Loader 4 software; Take care during Binary-Hexa conversion. MSB first.
 
  const unsigned long IF_R_1 = 0x360028; //Calculated by Code Loader 4 software
  const unsigned long IF_N_1 = 0x100C11; //Divider 100 P=16
  const unsigned long RF_R_1 = 0x6002A;
  const unsigned long RF_N_1 = 0x1EA3;
  
  const unsigned long IF_R_2 = 0x360028; //Calculated by Code Loader 4 software
  const unsigned long IF_N_2 = 0x107C21; //Divider 1000 P=16
  const unsigned long RF_R_2 = 0x6002A;
  const unsigned long RF_N_2 = 0x1EA3;
  
  int bp;
  int SWstate = 0; //variable for reading the Switch
  unsigned long DTA;
  
  const int LE =  9; // Arduino pins
  const int DATA =  10;
  const int CLK =  11;
  const int SWpin = 8;
  const int ledPin = 13;


void setup() {       
  pinMode (LE, OUTPUT);  // latch 
  pinMode (CLK, OUTPUT);  // clock
  pinMode (DATA, OUTPUT);  // data
  pinMode (SWpin, INPUT); //switch input
  digitalWrite(SWpin, HIGH); // turn on pullup resistor
  pinMode(ledPin, OUTPUT); //LED
  digitalWrite(LE,LOW); // clear LE line
  digitalWrite(CLK,LOW); // clear CLK line


//while(true) { // While enable: Start loop and send SPI signals forever. Better to not use due output jitter.
                 // While disable: Power ON, read Switch and send SPI only one time. Need power restart in case of switch changed.
    
 SWstate = digitalRead(SWpin); //Read Switch input
 if (SWstate == HIGH) { 
 digitalWrite(ledPin, HIGH); //LED ON = Divider 100
 
 DTA = IF_R_1;    // Send setup parameters_1
 SendWord();
 DTA = IF_N_1;
 SendWord();
 DTA = RF_R_1;
 SendWord();
 DTA = RF_N_1;
 SendWord();
 }  
 
 else {
 digitalWrite(ledPin, LOW); //LED OFF = Divider 1000
 
 DTA= IF_R_2;    // Send setup parameters_2
 SendWord();
 DTA = IF_N_2;
 SendWord();
 DTA = RF_R_2;
 SendWord();
 DTA = RF_N_2;
 SendWord();
} 
delay (500); //jitter reduced due SPI refresh

//}   // uncomment togheter with "while true"

}



void loop() {  } // loop closed
   
   
  int SendWord() {
  bp = 22;
  do{
  bp = bp - 1;   //loop through bit positions 22 to 0
  digitalWrite(CLK,LOW); 
  digitalWrite(DATA, bitRead(DTA,bp) ); 
  digitalWrite(CLK,HIGH); 
  }while(bp>0); 
  
  digitalWrite(CLK,LOW); 
  digitalWrite(DATA,LOW);

  digitalWrite(LE,HIGH);   // Set LE to latch data
  delayMicroseconds(4); // 
  digitalWrite(LE,LOW);
}









